package com.qianhe.system.controller;

import com.alibaba.fastjson.JSON;
import com.qianhe.system.domain.CCBNotifyInfo;
import com.qianhe.system.domain.WaterOrderLog;
import com.qianhe.system.mapper.WaterOrderLogMapper;
import com.qianhe.system.mapper.WaterOrderMapper;
import com.qianhe.system.vo.WaterOrderVo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


import java.math.BigDecimal;


/**
 * @author yc
 * @version 1.0
 * @className CCBBackController
 * @date 2024/3/28 11:00
 * @description 建行回调
 */
@RestController
@Slf4j
@RequestMapping("/ccbback")
public class CCBBackController {

    @Autowired
    private WaterOrderLogMapper orderLogMapper;

    @Autowired
    private WaterOrderMapper orderMapper;

    @PostMapping("/jh/notify")
    public String pay(CCBNotifyInfo notifyInfo) {
        log.info("建行回调通知参数[{}]", JSON.toJSONString(notifyInfo));
        String src = "POSID=" + notifyInfo.getPOSID() + "&BRANCHID=" + notifyInfo.getBRANCHID() + "&ORDERID=" + notifyInfo.getORDERID() +
                "&PAYMENT=" + notifyInfo.getPAYMENT() + "&CURCODE=" + notifyInfo.getCURCODE() + "&REMARK1=" + notifyInfo.getREMARK1() + "&REMARK2=" + notifyInfo.getREMARK2() + "&ACC_TYPE=" + notifyInfo.getACC_TYPE() +
                "&SUCCESS=" + notifyInfo.getSUCCESS() + "&TYPE=" + notifyInfo.getTYPE() + "&REFERER=" + notifyInfo.getREFERER() + "&CLIENTIP=" + notifyInfo.getCLIENTIP();
        if (notifyInfo.getSUCCESS().equals("Y")) {
            // 这里需要调用建行龙支付提供的查询订单接口以保证订单确实支付成功
           /* SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssX");
            Date date = sdf.parse(successTime);*/
            WaterOrderLog orderLog = new WaterOrderLog();
            orderLog.setPayNum(notifyInfo.getORDERID());
            //orderLog.setPayTime(date);
            orderLog.setPayMoney(new BigDecimal(notifyInfo.getPAYMENT()));
            int iLog = orderLogMapper.insertWaterOrderLog(orderLog);
            WaterOrderVo orderVo = new WaterOrderVo();
            orderVo.setOrderNum(notifyInfo.getORDERID());
            int orderI = orderMapper.updateByOrderNum(orderVo);
            log.info("验签通过");
            return "SUCCESS";
        } else {
            // 验签失败
            log.info("验签失败");
            return "FAIL";
        }
    }
}